diff --git a/src/main/java/net/minecraft/core/entity/EntityLiving.java b/src/main/java/net/minecraft/core/entity/Mob.java
similarity index 83%
rename from src/main/java/net/minecraft/core/entity/EntityLiving.java
rename to src/main/java/net/minecraft/core/entity/Mob.java
index 341074db2..137609321 100644
--- a/src/main/java/net/minecraft/core/entity/EntityLiving.java
+++ b/src/main/java/net/minecraft/core/entity/Mob.java
@@ -3,17 +3,18 @@ package net.minecraft.core.entity;
 import com.b100.utils.StringUtils;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.Global;
-import net.minecraft.core.HitResult;
+import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.data.gamerule.GameRules;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.enums.PlacementMode;
-import net.minecraft.core.item.Item;
-import net.minecraft.core.item.ItemFood;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.item.FoodItem;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.util.collection.NamespaceID;
@@ -22,7 +23,7 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 
 import java.util.ArrayList;
@@ -35,30 +36,100 @@ import java.util.Map;
 //            MathHelper, Block, StepSound, AxisAlignedBB,
 //            NBTTagCompound, ItemStack, MovingObjectPosition
 
-public abstract class EntityLiving extends Entity
+public abstract class Mob extends Entity
 {
+    public static final int DATA_VARIANT = 1;
+    public static final int DATA_HEALTH = 2;
+    protected Map<FoodItem, ConsumedFood> consumedFood = new HashMap<FoodItem, ConsumedFood>();
+    public int heartsHalvesLife;
+//    public float timeOffs;
+//    public float rotA;
+    public float yBodyRot;
+    public float yBodyRotO;
+    protected float ridingRotUnused;
+    protected float prevRidingRotUnused;
+    protected float unusedRotation1;
+    protected float prevRotationUnused;
+//    protected boolean hasHair;
+//    protected boolean allowAlpha;
+//    protected float rotOffs;
+    protected String entityType;
+//    protected float bobStrength;
+    protected int scoreValue;
+    //    protected float renderOffset;
+    public boolean isMultiplayerEntity;
+    public float prevSwingProgress;
+    public float swingProgress;
+    public int prevHealth;
+    public int bonusHealth;
+    public int prevBonusHealth;
+    private int livingSoundTime;
+    public int hurtTime;
+    public int maxHurtTime;
+    public float attackedAtYaw;
+    public int deathTime;
+    public int attackTime;
+    public float prevCameraPitch;
+    public float cameraPitch;
+    protected boolean dead;
+    //    public int modelNum;
+//    public float animSpeed;
+    public float walkAnimSpeedO;
+    public float walkAnimSpeed;
+    public float walkAnimPos;
+    protected int newPosRotationIncrements;
+    protected double newPosX;
+    protected double newPosY;
+    protected double newPosZ;
+    protected double newRotationYaw;
+    protected double newRotationPitch;
+//    float fallTime;
+    protected int lastDamage;
+    protected int entityAge;
+    protected float moveStrafing;
+    protected float moveForward;
+    protected float randomYawVelocity;
+    protected boolean isJumping;
+    protected float defaultPitch;
+    protected float moveSpeed;
+    protected float noclipSpeed = 0.5f;
+    protected float flightSmoothness = 0.5f;
+    private Entity currentTarget;
+    protected int numTicksToChaseTarget;
+    public String nickname = "";
+    public byte chatColor = 0;
+    protected NamespaceID textureIdentifier = new NamespaceID("minecraft", "char");
+    protected float lastStrafe = 0.0f;
+
+    public boolean isSkating = false;
 
-    public EntityLiving(World world)
+    public Direction rotationLock = null;
+    public Direction rotationLockHorizontal = null;
+    public Direction rotationLockVertical = null;
+    public PlacementMode placementModeOverride = PlacementMode.FACING;
+    public List<WeightedRandomLootObject> mobDrops = new ArrayList<>();
+
+    public Mob(World world)
     {
         super(world);
         heartsHalvesLife = 20;
-        renderYawOffset = 0.0F;
-        prevRenderYawOffset = 0.0F;
-        unusedBool1 = true;
-        unusedBool2 = true;
-        unusedRotation2 = 0.0F;
+        yBodyRot = 0.0F;
+        yBodyRotO = 0.0F;
+//        hasHair = true;
+//        allowAlpha = true;
+//        rotOffs = 0.0F;
         entityType = null;
-        unusedFloat1 = 1.0F;
+//        bobStrength = 1.0F;
         scoreValue = 0;
-        unusedFloat2 = 0.0F;
+//        renderOffset = 0.0F;
         isMultiplayerEntity = false;
         attackedAtYaw = 0.0F;
         deathTime = 0;
         attackTime = 0;
         dead = false;
-        unusedInt = -1;
-        unusedFloat4 = (float)(java.lang.Math.random() * 0.9D + 0.1D);
-        unusedFloat3 = 0.0F;
+//        modelNum = -1;
+//        animSpeed = (float)(Math.random() * 0.9D + 0.1D);
+//        fallTime = 0.0F;
         lastDamage = 0;
         entityAge = 0;
         isJumping = false;
@@ -66,44 +137,50 @@ public abstract class EntityLiving extends Entity
         moveSpeed = 0.7F;
         numTicksToChaseTarget = 0;
         blocksBuilding = true;
-        unusedRotationPitch = (float)(java.lang.Math.random() + 1.0D) * 0.01F;
+//        rotA = (float)(Math.random() + 1.0D) * 0.01F;
         setPos(x, y, z);
-        unusedRotationPitch2 = (float) java.lang.Math.random() * 12398F;
-        yRot = (float)(java.lang.Math.random() * 3.1415927410125732D * 2D);
+//        timeOffs = (float) Math.random() * 12398F;
+        yRot = (float)(Math.random() * Math.PI * 2D);
         footSize = 0.5F;
-        int variant = random.nextInt(Byte.MAX_VALUE);
-        entityData.define(1, Byte.valueOf((byte)variant));
+
+        int variant = random.nextInt(0xFF);
+        entityData.define(DATA_VARIANT, (byte) variant);
+        entityData.define(DATA_HEALTH, getMaxHealth());
         setSkinVariant(variant);
+
         speed = 0.1f;
         flySpeed = 0.02f;
-        entityData.define(2, getMaxHealth());
         this.mobDrops = new ArrayList<>();
     }
     @Override
-	protected void init()
+	protected void defineSynchedData()
     {
-        if (this.mobDrops == null) {
-            this.mobDrops = new ArrayList<>();
-        }
     }
 
     public boolean canEntityBeSeen(Entity entity)
     {
-        return world.checkBlockCollisionBetweenPoints(Vec3d.createVector(x, y + (double) getHeadHeight(), z), Vec3d.createVector(entity.x, entity.y + (double)entity.getHeadHeight(), entity.z)) == null;
+        return world.checkBlockCollisionBetweenPoints(Vec3.getTempVec3(x, y + (double) getHeadHeight(), z), Vec3.getTempVec3(entity.x, entity.y + (double)entity.getHeadHeight(), entity.z)) == null;
     }
 
     @Override
 	public String getEntityTexture() {
-        return String.format("/assets/%s/textures/entity/%s/%d.png", textureIdentifier.namespace, textureIdentifier.value, getSkinVariant());
+        SkinVariantList variantList = Global.accessor.getSkinVariantList();
+        String basePath = String.format("/assets/%s/textures/entity/%s/", textureIdentifier.namespace, textureIdentifier.value);
+        return basePath + getTextureReference() + ".png";
+    }
+
+    public String getTextureReference() {
+        SkinVariantList variantList = Global.accessor.getSkinVariantList();
+        String basePath = String.format("/assets/%s/textures/entity/%s/", textureIdentifier.namespace, textureIdentifier.value);
+        return variantList.getSkinReference(basePath + "variants.json", "0", getSkinVariant());
     }
 
     public int getSkinVariant() {
-        int skinVariantCount = Global.accessor.getSkinVariantList().getNumSkinsForEntity(getClass());
-        return entityData.getByte(1) % skinVariantCount;
+        return Byte.toUnsignedInt(entityData.getByte(DATA_VARIANT));
     }
 
     public void setSkinVariant(int skinVariant) {
-        entityData.set(1, (byte)(MathHelper.clamp(skinVariant, 0, Byte.MAX_VALUE)));
+        entityData.set(DATA_VARIANT, (byte) (skinVariant));
     }
 
     public String getDefaultEntityTexture() {
@@ -128,7 +205,7 @@ public abstract class EntityLiving extends Entity
         return bbHeight * 0.85F;
     }
 
-    public int getTalkInterval()
+    public int getAmbientSoundInterval()
     {
         return 80;
     }
@@ -139,10 +216,10 @@ public abstract class EntityLiving extends Entity
     }
 
     @Override
-    public boolean interact(EntityPlayer entityplayer)
+    public boolean interact(Player entityplayer)
     {
         ItemStack item = entityplayer.inventory.getCurrentItem();
-        if (item != null && item.itemID == Item.label.id && item.hasCustomName())
+        if (item != null && item.itemID == Items.LABEL.id && item.hasCustomName())
         {
             if(item.hasCustomColor()) {
             	this.chatColor = item.getCustomColor();
@@ -189,7 +266,7 @@ public abstract class EntityLiving extends Entity
         super.baseTick();
         if(random.nextInt(1000) < livingSoundTime++)
         {
-            livingSoundTime = -getTalkInterval();
+            livingSoundTime = -getAmbientSoundInterval();
             playLivingSound();
         }
         if(isAlive() && isInWall() && !noPhysics)
@@ -219,7 +296,7 @@ public abstract class EntityLiving extends Entity
             deathTime++;
             if(deathTime > 20)
             {
-                onEntityDeath();
+                beforeRemove();
                 remove();
                 for(int j = 0; j < 20; j++)
                 {
@@ -231,18 +308,18 @@ public abstract class EntityLiving extends Entity
 
             }
         }
-        List<ItemFood> finishedFood = new ArrayList<>();
-        for (Map.Entry<ItemFood, ConsumedFood> entry : consumedFood.entrySet()) {
+        List<FoodItem> finishedFood = new ArrayList<>();
+        for (Map.Entry<FoodItem, ConsumedFood> entry : consumedFood.entrySet()) {
             entry.getValue().tick();
             if (entry.getValue().isFinished()) {
                 finishedFood.add(entry.getKey());
             }
         }
-        for (ItemFood food : finishedFood) {
+        for (FoodItem food : finishedFood) {
             consumedFood.remove(food);
         }
         prevRotationUnused = unusedRotation1;
-        prevRenderYawOffset = renderYawOffset;
+        yBodyRotO = yBodyRot;
         yRotO = yRot;
         xRotO = xRot;
     }
@@ -311,8 +388,8 @@ public abstract class EntityLiving extends Entity
         onLivingUpdate();
         double d = x - xo;
         double d1 = z - zo;
-        float f = MathHelper.sqrt_double(d * d + d1 * d1);
-        float f1 = renderYawOffset;
+        float f = MathHelper.sqrt(d * d + d1 * d1);
+        float f1 = yBodyRot;
         float f2 = 0.0F;
         ridingRotUnused = prevRidingRotUnused;
         float f3 = 0.0F;
@@ -320,7 +397,7 @@ public abstract class EntityLiving extends Entity
         {
             f3 = 1.0F;
             f2 = f * 3F;
-            f1 = ((float) java.lang.Math.atan2(d1, d) * 180F) / 3.141593F - 90F;
+            f1 = ((float) java.lang.Math.atan2(d1, d) * 180F) / MathHelper.PI - 90F;
         }
         if(swingProgress > 0.0F)
         {
@@ -332,11 +409,11 @@ public abstract class EntityLiving extends Entity
         }
         prevRidingRotUnused = prevRidingRotUnused + (f3 - prevRidingRotUnused) * 0.3F;
         float f4;
-        for(f4 = f1 - renderYawOffset; f4 < -180F; f4 += 360F) { }
+        for(f4 = f1 - yBodyRot; f4 < -180F; f4 += 360F) { }
         for(; f4 >= 180F; f4 -= 360F) { }
-        renderYawOffset += f4 * 0.3F;
+        yBodyRot += f4 * 0.3F;
         float f5;
-        for(f5 = yRot - renderYawOffset; f5 < -180F; f5 += 360F) { }
+        for(f5 = yRot - yBodyRot; f5 < -180F; f5 += 360F) { }
         for(; f5 >= 180F; f5 -= 360F) { }
         boolean flag = f5 < -90F || f5 >= 90F;
         if(f5 < -75F)
@@ -347,10 +424,10 @@ public abstract class EntityLiving extends Entity
         {
             f5 = 75F;
         }
-        renderYawOffset = yRot - f5;
+        yBodyRot = yRot - f5;
         if(f5 * f5 > 2500F)
         {
-            renderYawOffset += f5 * 0.2F;
+            yBodyRot += f5 * 0.2F;
         }
         if(flag)
         {
@@ -358,8 +435,8 @@ public abstract class EntityLiving extends Entity
         }
         for(; yRot - yRotO < -180F; yRotO -= 360F) { }
         for(; yRot - yRotO >= 180F; yRotO += 360F) { }
-        for(; renderYawOffset - prevRenderYawOffset < -180F; prevRenderYawOffset -= 360F) { }
-        for(; renderYawOffset - prevRenderYawOffset >= 180F; prevRenderYawOffset += 360F) { }
+        for(; yBodyRot - yBodyRotO < -180F; yBodyRotO -= 360F) { }
+        for(; yBodyRot - yBodyRotO >= 180F; yBodyRotO += 360F) { }
         for(; xRot - xRotO < -180F; xRotO -= 360F) { }
         for(; xRot - xRotO >= 180F; xRotO += 360F) { }
         unusedRotation1 += f2;
@@ -385,10 +462,10 @@ public abstract class EntityLiving extends Entity
         heartsFlashTime = heartsHalvesLife / 2;
     }
     public int getHealth(){
-        return entityData.getInt(2);
+        return entityData.getInt(DATA_HEALTH);
     }
     public void setHealthRaw(int health){
-        entityData.set(2, health);
+        entityData.set(DATA_HEALTH, health);
     }
     public int getMaxHealth(){
         return 10;
@@ -403,7 +480,7 @@ public abstract class EntityLiving extends Entity
         return totalHealingRemaining;
     }
 
-    public void eatFood(ItemFood food) {
+    public void eatFood(FoodItem food) {
         if (food == null) return;
         if (food.getTicksPerHeal() == 0 || world.getGameRuleValue(GameRules.INSTANT_HEALING)) {
             heal(food.getHealAmount());
@@ -428,7 +505,7 @@ public abstract class EntityLiving extends Entity
         {
             return false;
         }
-        limbYaw = 1.5F;
+        walkAnimSpeed = 1.5F;
         boolean flag = true;
         if((float) heartsFlashTime > (float)heartsHalvesLife / 2.0F)
         {
@@ -461,7 +538,7 @@ public abstract class EntityLiving extends Entity
                     d = (java.lang.Math.random() - java.lang.Math.random()) * 0.01D;
                 }
 
-                attackedAtYaw = (float)((java.lang.Math.atan2(d1, d) * 180D) / 3.1415927410125732D) - yRot;
+                attackedAtYaw = (float)((java.lang.Math.atan2(d1, d) * 180D) / Math.PI) - yRot;
                 knockBack(attacker, damage, d, d1);
             } else
             {
@@ -519,7 +596,7 @@ public abstract class EntityLiving extends Entity
 
     public void knockBack(Entity entity, int i, double d, double d1)
     {
-        float f = MathHelper.sqrt_double(d * d + d1 * d1);
+        float f = MathHelper.sqrt(d * d + d1 * d1);
         float f1 = 0.4F;
         xd /= 2D;
         yd /= 2D;
@@ -546,7 +623,7 @@ public abstract class EntityLiving extends Entity
         dead = true;
         if(!world.isClientSide)
         {
-            dropFewItems();
+            dropDeathItems();
         }
         if (vehicle != null){
             vehicle.ejectRider();
@@ -573,7 +650,7 @@ public abstract class EntityLiving extends Entity
         {
             return String.format("%s%s swam in lava.", name, deathMsgColor);
         }
-        if (world.getBlockId(MathHelper.floor_double(x), MathHelper.floor_double(y), MathHelper.floor_double(z)) == Block.spikes.id)
+        if (world.getBlockId(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z)) == Blocks.SPIKES.id)
         {
             return String.format("%s%s got impaled.", name, deathMsgColor);
         }
@@ -591,7 +668,7 @@ public abstract class EntityLiving extends Entity
         }
         return String.format("%s%s died", name, deathMsgColor);
     }
-    protected void dropFewItems()
+    protected void dropDeathItems()
     {
         List<WeightedRandomLootObject> drops = getMobDrops();
         if (drops != null){
@@ -610,14 +687,14 @@ public abstract class EntityLiving extends Entity
     }
 
     @Override
-	protected void causeFallDamage(float f)
+	protected void causeFallDamage(float distance)
     {
-        super.causeFallDamage(f);
-        int i = (int) java.lang.Math.ceil(f - 3F);
+        super.causeFallDamage(distance);
+        int i = (int) java.lang.Math.ceil(distance - 3F);
         if(i > 0)
         {
             hurt(null, i, DamageType.FALL);
-            int j = world.getBlockId(MathHelper.floor_double(x), MathHelper.floor_double(y - 0.2D - (double) heightOffset), MathHelper.floor_double(z));
+            int j = world.getBlockId(MathHelper.floor(x), MathHelper.floor(y - 0.2D - (double) heightOffset), MathHelper.floor(z));
             if(j > 0)
             {
                 world.playBlockSoundEffect(this, this.x, this.y - this.heightOffset, this.z, Block.blocksList[j], EnumBlockSoundEffectType.ENTITY_LAND);
@@ -640,7 +717,7 @@ public abstract class EntityLiving extends Entity
 
     public void moveEntityWithHeading(float moveStrafing, float moveForward)
     {
-        int floorBlockId = world.getBlockId(MathHelper.floor_double(x), MathHelper.floor_double(bb.minY) - 1, MathHelper.floor_double(z));
+        int floorBlockId = world.getBlockId(MathHelper.floor(x), MathHelper.floor(bb.minY) - 1, MathHelper.floor(z));
         this.muteStepSounds = false;
         this.isSkating = false;
 
@@ -727,8 +804,8 @@ public abstract class EntityLiving extends Entity
                 moveRelative(moveStrafing * 0.1f, 0.0f, 0.125f);
                 float speedBoost = 0.025f;
                 float maxSpeed = 0.5f;
-                float dx = MathHelper.sin((yRot * 3.141593F) / 180F);
-                float dz = MathHelper.cos((yRot * 3.141593F) / 180F);
+                float dx = MathHelper.sin((yRot * MathHelper.PI) / 180F);
+                float dz = MathHelper.cos((yRot * MathHelper.PI) / 180F);
                 double newMotionX = xd - speedBoost * dx;
                 double newMotionZ = zd + speedBoost * dz;
                 if ((newMotionX * newMotionX) + (newMotionZ * newMotionZ) < maxSpeed * maxSpeed)
@@ -748,7 +825,7 @@ public abstract class EntityLiving extends Entity
                 movementScale = 0.5460001F;
                 if(floorBlockId > 0)
                 {
-                    movementScale = Block.blocksList[floorBlockId].movementScale * 0.91F;
+                    movementScale = Block.blocksList[floorBlockId].friction * 0.91F;
                 }
             }
 
@@ -760,7 +837,7 @@ public abstract class EntityLiving extends Entity
                 movementScale = 0.5460001F;
                 if(floorBlockId > 0)
                 {
-                    movementScale = Block.blocksList[floorBlockId].movementScale * 0.91F;
+                    movementScale = Block.blocksList[floorBlockId].friction * 0.91F;
                 }
 
             }
@@ -803,23 +880,23 @@ public abstract class EntityLiving extends Entity
             xd *= movementScale;
             zd *= movementScale;
         }
-        prevLimbYaw = limbYaw;
+        walkAnimSpeedO = walkAnimSpeed;
         double d2 = x - xo;
         double d3 = z - zo;
-        float f5 = MathHelper.sqrt_double(d2 * d2 + d3 * d3) * 4F;
+        float f5 = MathHelper.sqrt(d2 * d2 + d3 * d3) * 4F;
         if(f5 > 1.0F)
         {
             f5 = 1.0F;
         }
-        limbYaw += (f5 - limbYaw) * 0.4F;
-        limbSwing += limbYaw;
+        walkAnimSpeed += (f5 - walkAnimSpeed) * 0.4F;
+        walkAnimPos += walkAnimSpeed;
     }
 
     public boolean canClimb()
     {
-        int i = MathHelper.floor_double(x);
-        int j = MathHelper.floor_double(bb.minY);
-        int k = MathHelper.floor_double(z);
+        int i = MathHelper.floor(x);
+        int j = MathHelper.floor(bb.minY);
+        int k = MathHelper.floor(z);
         Block block = world.getBlock(i, j, k);
         return block != null && block.isClimbable(world, i, j, k);
     }
@@ -904,7 +981,7 @@ public abstract class EntityLiving extends Entity
         } else
         if(!isMultiplayerEntity)
         {
-            updatePlayerActionState();
+            updateAI();
         }
         boolean flag = isInWater();
         boolean flag1 = isInLava();
@@ -927,7 +1004,7 @@ public abstract class EntityLiving extends Entity
         moveForward *= 0.98F;
         randomYawVelocity *= 0.9F;
         moveEntityWithHeading(moveStrafing, moveForward);
-        List list = world.getEntitiesWithinAABBExcludingEntity(this, bb.expand(0.20000000298023224D, 0.0D, 0.20000000298023224D));
+        List list = world.getEntitiesWithinAABBExcludingEntity(this, bb.grow(0.2D, 0.0D, 0.2D));
         if(list != null && list.size() > 0)
         {
             for(int i = 0; i < list.size(); i++)
@@ -968,7 +1045,7 @@ public abstract class EntityLiving extends Entity
 
     public void tryToDespawn()
     {
-        EntityPlayer entityplayer = world.getClosestPlayerToEntity(this, -1D);
+        Player entityplayer = world.getClosestPlayerToEntity(this, -1D);
         if(canDespawn() && entityplayer != null)
         {
             double d = entityplayer.x - x;
@@ -992,17 +1069,17 @@ public abstract class EntityLiving extends Entity
         }
     }
 
-    protected void updatePlayerActionState()
+    protected void updateAI()
     {
         entityAge++;
-        EntityPlayer entityplayer = world.getClosestPlayerToEntity(this, -1D);
+        Player entityplayer = world.getClosestPlayerToEntity(this, -1D);
         tryToDespawn();
         moveStrafing = 0.0F;
         moveForward = 0.0F;
         float f = 8F;
         if(random.nextFloat() < 0.02F)
         {
-            EntityPlayer entityplayer1 = world.getClosestPlayerToEntity(this, f);
+            Player entityplayer1 = world.getClosestPlayerToEntity(this, f);
             if(entityplayer1 != null)
             {
                 currentTarget = entityplayer1;
@@ -1014,7 +1091,7 @@ public abstract class EntityLiving extends Entity
         }
         if(currentTarget != null)
         {
-            faceEntity(currentTarget, 10F, func_25026_x());
+            lookAt(currentTarget, 10F, func_25026_x());
             if(numTicksToChaseTarget-- <= 0 || currentTarget.removed || currentTarget.distanceToSqr(this) > (double)(f * f))
             {
                 currentTarget = null;
@@ -1041,24 +1118,24 @@ public abstract class EntityLiving extends Entity
         return 40;
     }
 
-    public void faceEntity(Entity entity, float f, float f1)
+    public void lookAt(Entity entity, float f, float f1)
     {
-        double d = entity.x - x;
-        double d2 = entity.z - z;
-        double d1;
-        if(entity instanceof EntityLiving)
+        double x = entity.x - this.x;
+        double y = entity.z - z;
+        double y2;
+        if(entity instanceof Mob)
         {
-            EntityLiving entityliving = (EntityLiving)entity;
-            d1 = (y + (double) getHeadHeight()) - (entityliving.y + (double)entityliving.getHeadHeight());
+            Mob entityliving = (Mob)entity;
+            y2 = entityliving.y + entityliving.getHeadHeight() - (this.y + this.getHeadHeight());
         } else
         {
-            d1 = (entity.bb.minY + entity.bb.maxY) / 2D - (y + (double) getHeadHeight());
+            y2 = (entity.bb.minY + entity.bb.maxY) / 2D - (this.y + (double) getHeadHeight());
         }
-        double d3 = MathHelper.sqrt_double(d * d + d2 * d2);
-        float f2 = (float)((java.lang.Math.atan2(d2, d) * 180D) / 3.1415927410125732D) - 90F;
-        float f3 = (float)(-((java.lang.Math.atan2(d1, d3) * 180D) / 3.1415927410125732D));
-        xRot = -updateRotation(xRot, f3, f1);
-        yRot = updateRotation(yRot, f2, f);
+        double d3 = MathHelper.sqrt(x * x + y * y);
+        float f2 = (float)((Math.atan2(y, x) * 180D) / Math.PI) - 90F;
+        float f3 = (float)(-((Math.atan2(-y2, d3) * 180D) / Math.PI));
+        xRot = -rotationLerp(xRot, f3, f1);
+        yRot = rotationLerp(yRot, f2, f);
     }
 
     public boolean hasCurrentTarget()
@@ -1071,7 +1148,7 @@ public abstract class EntityLiving extends Entity
         return currentTarget;
     }
 
-    private float updateRotation(float f, float f1, float f2)
+    private float rotationLerp(float f, float f1, float f2) // Was called rotLerp in the b1.2 leak
     {
         float f3;
         for(f3 = f1 - f; f3 < -180F; f3 += 360F) { }
@@ -1087,15 +1164,15 @@ public abstract class EntityLiving extends Entity
         return f + f3;
     }
 
-    public void onEntityDeath()
+    public void beforeRemove()
     {
     }
 
-    public boolean getCanSpawnHere()
+    public boolean canSpawnHere()
     {
-        int blockX = MathHelper.floor_double(x);
-        int blockY = MathHelper.floor_double(bb.minY);
-        int blockZ = MathHelper.floor_double(z);
+        int blockX = MathHelper.floor(x);
+        int blockY = MathHelper.floor(bb.minY);
+        int blockZ = MathHelper.floor(z);
         if(Block.hasTag(world.getBlockId(blockX, blockY, blockZ), BlockTags.PREVENT_MOB_SPAWNS)) {
         	return false;
         }
@@ -1118,27 +1195,27 @@ public abstract class EntityLiving extends Entity
         return prevSwingProgress + f1 * partialTick;
     }
 
-    public Vec3d getPosition(float partialTick)
+    public Vec3 getPosition(float partialTick)
     {
         if(partialTick == 1.0F)
         {
-            return Vec3d.createVector(x, y, z);
+            return Vec3.getTempVec3(x, y, z);
         } else
         {
             double d = xo + (x - xo) * (double)partialTick;
             double d1 = yo + (y - yo) * (double)partialTick;
             double d2 = zo + (z - zo) * (double)partialTick;
-            return Vec3d.createVector(d, d1, d2);
+            return Vec3.getTempVec3(d, d1, d2);
         }
     }
 
     @Override
-	public Vec3d getLookAngle()
+	public Vec3 getLookAngle()
     {
         return getViewVector(1.0F);
     }
 
-    public Vec3d getViewVector(float partialTick)
+    public Vec3 getViewVector(float partialTick)
     {
         if(partialTick == 1.0F)
         {
@@ -1146,7 +1223,7 @@ public abstract class EntityLiving extends Entity
             float f3 = MathHelper.sin(-yRot * (MathHelper.PI / 180f) - MathHelper.PI);
             float f5 = -MathHelper.cos(-xRot * (MathHelper.PI / 180f));
             float f7 = MathHelper.sin(-xRot * (MathHelper.PI / 180f));
-            return Vec3d.createVector(f3 * f5, f7, f1 * f5);
+            return Vec3.getTempVec3(f3 * f5, f7, f1 * f5);
         }
         else
         {
@@ -1156,16 +1233,16 @@ public abstract class EntityLiving extends Entity
             float x = MathHelper.sin(-yaw * (MathHelper.PI / 180f) - MathHelper.PI);
             float y = MathHelper.sin(-pitch * (MathHelper.PI / 180f));
             float z = MathHelper.cos(-yaw * (MathHelper.PI / 180f) - MathHelper.PI);
-            return Vec3d.createVector(x * xzLen, y, z * xzLen);
+            return Vec3.getTempVec3(x * xzLen, y, z * xzLen);
         }
     }
 
     public HitResult rayTrace(double d, float partialTick)
     {
-        Vec3d vec3d = getPosition(partialTick);
-        Vec3d vec3d1 = getViewVector(partialTick);
-        Vec3d vec3d2 = vec3d.addVector(vec3d1.xCoord * d, vec3d1.yCoord * d, vec3d1.zCoord * d);
-        return world.checkBlockCollisionBetweenPoints(vec3d, vec3d2);
+        Vec3 vec3 = getPosition(partialTick);
+        Vec3 vec31 = getViewVector(partialTick);
+        Vec3 vec32 = vec3.add(vec31.x * d, vec31.y * d, vec31.z * d);
+        return world.checkBlockCollisionBetweenPoints(vec3, vec32);
     }
 
     public int getMaxSpawnedInChunk()
@@ -1183,7 +1260,7 @@ public abstract class EntityLiving extends Entity
     {
         if(byte0 == 2)
         {
-            limbYaw = 1.5F;
+            walkAnimSpeed = 1.5F;
             heartsFlashTime = heartsHalvesLife;
             hurtTime = maxHurtTime = 10;
             this.attackedAtYaw = attackedAtYaw;
@@ -1259,73 +1336,4 @@ public abstract class EntityLiving extends Entity
     	}
     	return xRot < 0.0f ? Direction.UP : Direction.DOWN;
     }
-
-    protected Map<ItemFood, ConsumedFood> consumedFood = new HashMap<ItemFood, ConsumedFood>();
-    public int heartsHalvesLife;
-    public float unusedRotationPitch2;
-    public float unusedRotationPitch;
-    public float renderYawOffset;
-    public float prevRenderYawOffset;
-    protected float ridingRotUnused;
-    protected float prevRidingRotUnused;
-    protected float unusedRotation1;
-    protected float prevRotationUnused;
-    protected boolean unusedBool1;
-    protected boolean unusedBool2;
-    protected float unusedRotation2;
-    protected String entityType;
-    protected float unusedFloat1;
-    protected int scoreValue;
-    protected float unusedFloat2;
-    public boolean isMultiplayerEntity;
-    public float prevSwingProgress;
-    public float swingProgress;
-    public int prevHealth;
-    public int bonusHealth;
-    public int prevBonusHealth;
-    private int livingSoundTime;
-    public int hurtTime;
-    public int maxHurtTime;
-    public float attackedAtYaw;
-    public int deathTime;
-    public int attackTime;
-    public float prevCameraPitch;
-    public float cameraPitch;
-    protected boolean dead;
-    public int unusedInt;
-    public float unusedFloat4;
-    public float prevLimbYaw;
-    public float limbYaw;
-    public float limbSwing;
-    protected int newPosRotationIncrements;
-    protected double newPosX;
-    protected double newPosY;
-    protected double newPosZ;
-    protected double newRotationYaw;
-    protected double newRotationPitch;
-    float unusedFloat3;
-    protected int lastDamage;
-    protected int entityAge;
-    protected float moveStrafing;
-    protected float moveForward;
-    protected float randomYawVelocity;
-    protected boolean isJumping;
-    protected float defaultPitch;
-    protected float moveSpeed;
-    protected float noclipSpeed = 0.5f;
-    protected float flightSmoothness = 0.5f;
-    private Entity currentTarget;
-    protected int numTicksToChaseTarget;
-    public String nickname = "";
-    public byte chatColor = 0;
-    protected NamespaceID textureIdentifier = new NamespaceID("minecraft", "char");
-    protected float lastStrafe = 0.0f;
-    
-    public boolean isSkating = false;
-
-    public Direction rotationLock = null;
-    public Direction rotationLockHorizontal = null;
-    public Direction rotationLockVertical = null;
-    public PlacementMode placementModeOverride = PlacementMode.FACING;
-    public List<WeightedRandomLootObject> mobDrops = new ArrayList<>();
 }
